#include <SI_EFM8BB1_Register_Enums.h>
#include "InitDevice.h"
#include "hal.h"

void SiLabs_Startup(void) {
	// Disable the watchdog here
	enter_DefaultMode_from_RESET();
}

int pwmChannel = 0;

void demo1() {
	int a, b, c;
	for (a = 0; a < 16; a++)
		for (b = 0; b < 16; b++)
			for (c = 0; c < 16; c += 4) {
				setPWM(RGB_R, a);
				setPWM(RGB_G, b);
				setPWM(RGB_B, c);
				delay(10);
			}
}

void demo2() {
	int i;
	setPWM(0, RGB_R);
	setPWM(0, RGB_G);
	setPWM(0, RGB_B);

	for (i = 0; i < 255; i++) {
		setPWM(RGB_G, i);
		delay(10);
	}
	setPWM(RGB_G, 0);

	for (i = 0; i < 255; i++) {
		setPWM(RGB_R, i);
		delay(10);
	}
	setPWM(RGB_R, 0);

	for (i = 0; i < 255; i++) {
		setPWM(RGB_B, i);
		delay(10);
	}
	setPWM(RGB_B, 0);
}

void demo3() {
	uint16_t i;
	for (i = 0; i < 255; i++) {
		setPWM(pwmChannel, i);
		if (buttonState()) {
			setPWM(pwmChannel, 0);
			pwmChannel++;
			if (pwmChannel > 2)
				pwmChannel = 0;
		}
		delay(10);
	}
}

uint32_t colors[] =
		{ 0x010101, 0x020202, 0x040404, 0x080808, 0x101010, 0x202020 };
int times[] = { 1000, 1000, 500, 1000, 1000, 50 };
void demo4() {
	int i;
	setColor(0x400000);
	delay(1000);
	setColor(0);
	while (!buttonState()) {
	}
	for (i = 0; i < 3; i++) {
		while (buttonState()) {
		}
		if (getButtonPressedTime() > times[i * 2])
			return;
		setColor(colors[i] * 2);
		while (!buttonState()) {
		}
		if (getButtonReleasedTime() < times[i * 2 + 1])
			return;
		setColor(colors[i] * 2 + 1);
	}
	setColor(0x404040);
	delay(300);
	setColor(0);
	delay(300);
	setColor(0x404040);
	delay(300);
	setColor(0);
	delay(300);
	setColor(0x404040);
	delay(300);
	setColor(0);
	delay(300);

}

void main(void) {
	setColor(0x80000);

	while (1) {
		/*setColor(0x555555);
		 delay(1000);
		 setColor(0);
		 delay(1000);*/
		/*setColor(0x80000);
		 delay(1000);
		 setColor(0x800);
		 delay(1000);
		 setColor(0x80000);
		 delay(1000);
		 setColor(0x800);
		 delay(1000);*/
		//demo1();
		//	demo2();
		//demo3();
		demo4();
	}
}
